% plot the time to find a target in 2d and 3d

set(0,                           ...
   'defaultaxesfontsize', 20,   ...
   'defaultaxeslinewidth', 1.0, ...
   'defaultlinelinewidth', 1.2, ...
   'defaultpatchlinewidth', 0.7);

x = [0.001:.001:1];
T2d = (log(1./x)+(x.^2-1)/2)/2;

T3d = (1./x+x.^2/2-3/2)/3;

figure(1)
plot(x,T2d,x,T3d,'linewidth',2)
legend('2-d','3-d','fontsize',20)
xlabel('\rho/R','fontsize',20)
ylabel('T(R)R^2/D','fontsize',20)
axis([0 1 0 10])

